Package org.zkoss.stateless.sul

## Interface ICheckboxBase<I extends ICheckboxBase>

- All Superinterfaces:
    `IChildrenOfInputgroup<I>`, `IComponent<I>`, `IHtmlBasedComponent<I>`, `ILabelElement<I>`, `ILabelImageElement<I>`, `IXulElement<I>`
  All Known Subinterfaces:
    `ICheckbox`, `IRadio`

      public interface ICheckboxBase<I extends ICheckboxBase>
      extends ILabelImageElement<I>

  Immutable `ICheckbox` base component.
  Author:
    katherine

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.String` | `getAutodisable()` | Returns a list of component IDs that shall be disabled when the user clicks this component.
    `java.lang.String` | `getName()` | Returns the name of this component.
    `java.lang.Object` | `getValue()` | Returns the value.
    `default boolean` | `isChecked()` | Returns whether it is checked.
    `default boolean` | `isDisabled()` | Sets whether it is disabled.
    `default boolean` | `isIndeterminate()` | Return whether component is in indeterminate state.
    `I` | `withAutodisable​(java.lang.String autodisable)` | Returns a copy of `this` immutable component with the specified `autodisable`.
    `I` | `withChecked​(boolean checked)` | Returns a copy of `this` immutable component with the specified `checked`.
    `I` | `withDisabled​(boolean disabled)` | Returns a copy of `this` immutable component with the specified `disabled`.
    `I` | `withIndeterminate​(boolean indeterminate)` | Returns a copy of `this` immutable component with the specified `indeterminate`.
    `I` | `withName​(java.lang.String name)` | Returns a copy of `this` immutable component with the specified `name`.
    `I` | `withValue​(java.lang.Object value)` | Returns a copy of `this` immutable component with the specified `value`.

    - ### Methods inherited from interface org.zkoss.stateless.sul.IComponent

      `getAction, getActions, getClientAttributes, getId, getMold, getWidgetClass, getWidgetListeners, getWidgetOverrides, isVisible, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withActions, withActions, withClientAttribute, withClientAttributes, withId, withMold, withVisible, withWidgetClass, withWidgetListener, withWidgetListeners, withWidgetOverride, withWidgetOverrides`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IHtmlBasedComponent

      `getClientAction, getDraggable, getDroppable, getHeight, getHflex, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTooltiptext, getTop, getVflex, getWidth, getZclass, getZIndex, isFocus, withClientAction, withDraggable, withDroppable, withFocus, withHeight, withHflex, withLeft, withRenderdefer, withSclass, withStyle, withTabindex, withTabindex, withTooltiptext, withTop, withVflex, withWidth, withZclass, withZIndex`

    - ### Methods inherited from interface org.zkoss.stateless.sul.ILabelElement

      `getLabel, withLabel`

    - ### Methods inherited from interface org.zkoss.stateless.sul.ILabelImageElement

      `getHoverImage, getIconSclass, getIconSclasses, getIconTooltip, getIconTooltips, getImage, isPreloadImage, withHoverImage, withIconSclass, withIconSclasses, withIconTooltip, withIconTooltips, withImage, withPreloadImage`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IXulElement

      `getContext, getCtrlKeys, getPopup, getTooltip, withContext, withCtrlKeys, withPopup, withTooltip`

- - ### Method Detail

    - #### getValue

          @Nullable
          java.lang.Object getValue()

      Returns the value.

      Default: `null`.

    - #### withValue

          I withValue​(@Nullable
                      java.lang.Object value)

      Returns a copy of `this` immutable component with the specified `value`.

      Sets the value of the component.

      Parameters:
        `value` - The value of the component.

        Default: `null`.

      Returns:
        A modified copy of the `this` object

    - #### getAutodisable

          @Nullable
          java.lang.String getAutodisable()

      Returns a list of component IDs that shall be disabled when the user clicks this component.

      Default: `null`

    - #### withAutodisable

          I withAutodisable​(@Nullable
                            java.lang.String autodisable)

      Returns a copy of `this` immutable component with the specified `autodisable`.

      Sets a list of component IDs that shall be disabled when the user clicks this component.

      Parameters:
        `autodisable` - The value of the component.

        Default: `null`.

      Returns:
        A modified copy of the `this` object

    - #### getName

          @Nullable
          java.lang.String getName()

      Returns the name of this component.

      Default: `null`.

      Don't use this method if your application is purely based on ZK's event-driven model.

      The name is used only to work with "legacy" Web application that handles user's request by servlets. It works only with HTTP/HTML-based browsers. It doesn't work with other kind of clients.

    - #### withName

          I withName​(@Nullable
                     java.lang.String name)

      Returns a copy of `this` immutable component with the specified `name`.

      Sets the name of this component.

      Don't use this method if your application is purely based on ZK's event-driven model.

      The name is used only to work with "legacy" Web application that handles user's request by servlets. It works only with HTTP/HTML-based browsers. It doesn't work with other kind of clients.

      Parameters:
        `name` - The value of the component.

        Default: `null`.

      Returns:
        A modified copy of the `this` object

    - #### isDisabled

          default boolean isDisabled()

      Sets whether it is disabled.

      Default: `false`

    - #### withDisabled

          I withDisabled​(boolean disabled)

      Returns a copy of `this` immutable component with the specified `disabled`.

      Sets whether it is disabled.

      Parameters:
        `disabled` - `true` to disable this component.

        Default: `false`.

      Returns:
        A modified copy of the `this` object

    - #### isIndeterminate

          default boolean isIndeterminate()

      Return whether component is in indeterminate state. Default: `false`.
      Returns:
        true if the component is indeterminate

    - #### withIndeterminate

          I withIndeterminate​(boolean indeterminate)

      Returns a copy of `this` immutable component with the specified `indeterminate`.

      Sets whether the component is in indeterminate state.

      Parameters:
        `indeterminate` - Whether the component is in indeterminate state.

        Default: `false`.

      Returns:
        A modified copy of the `this` object

    - #### isChecked

          default boolean isChecked()

      Returns whether it is checked.

      Default: `false`.

    - #### withChecked

          I withChecked​(boolean checked)

      Returns a copy of `this` immutable component with the specified `checked`.

      Sets whether it is checked.

      Parameters:
        `checked` - Whether it is checked.

        Default: `false`.

      Returns:
        A modified copy of the `this` object